#include "qtxpm.h"
#include <QFileDialog>
#include <QTextStream>

#include <QMessageBox>
QtXPM::QtXPM(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	ui.setupUi(this);
	init_statusBar();
    connect(ui.pushButtonTransfer,SIGNAL(clicked()),this,SLOT(TransferImage()));
    connect(ui.pushButtonShow,SIGNAL(clicked()),this,SLOT(ShowXpmFile()));
}

QtXPM::~QtXPM()
{

}
void QtXPM::init_statusBar()
{

	QStatusBar *bar=ui.statusBar;//ȡ״̬
    first_statusLabel= new QLabel;//½ǩ
	first_statusLabel->setMinimumSize(270,20);//ñǩߴ
    first_statusLabel->setFrameShape(QFrame::WinPanel);//״
    first_statusLabel->setFrameShadow(QFrame::Sunken);//Ӱ
    bar->addWidget(first_statusLabel);
	first_statusLabel->setText(QObject::tr(": QQ:405109066  ʥϻƼ ܱվ(mms goose sv)"));//ʼ
}

void QtXPM::ShowXpmFile()
{

	static QString  strDir="";
	//QDir dir=QFileDialog::directory();
	//dir.absoluteFilePath
	 QString imagefile = QFileDialog::getOpenFileName(this, QObject::tr("..."),strDir, QObject::tr("xpm (*.xpm);;All Files (*)"));
     if (!imagefile.isEmpty())
	 {
		 strDir=imagefile.left(imagefile.lastIndexOf("/"));

		 ui.lineEditXpmFile->setText(imagefile);
		 ShowImage();
	 }
	
}
void QtXPM::TransferImage()
{
	 static QString  strDir="";
	 QString imagefile = QFileDialog::getOpenFileName(this, QObject::tr("..."),strDir, QObject::tr("jpg (*.jpg);;gif (*.gif);;png (*.png );;bmp (*.bmp);;All Files (*)"));
     if (!imagefile.isEmpty())
	 {
	    strDir=imagefile.left(imagefile.lastIndexOf("/"));
		ui.lineEditImageFile->setText(imagefile);
		QImage image;
		QString imagefile;
		QString xpmfile;
		imagefile=ui.lineEditImageFile->text();
		bool ok = image.load(imagefile, 0);
		if(!ok)
		{
		   QMessageBox::information(0,"warning", QObject::tr("Load: %1 failed!").arg(imagefile));
		   return ;
		}
		xpmfile = imagefile.left(imagefile.lastIndexOf(".")) + ".xpm";
		ui.lineEditXpmFile->setText(xpmfile);
		image.save(xpmfile, "XPM");

		TransferXpmName(xpmfile);


		ShowImage();
	 }

}
void QtXPM::ShowImage()
{ 
	QString xpmfile;
	xpmfile=ui.lineEditXpmFile->text();
	QImage* img=new QImage;        
	if(! (img->load(xpmfile) ) ) //ͼ     
	{            
		QMessageBox::information(this,QObject::tr("ͼʧ"),QObject::tr("ͼʧ!"));
		delete img;            
		return;     
	}   
	ui.labelImage->setPixmap(QPixmap::fromImage(*img));
	
}
void QtXPM::TransferXpmName(const QString &strfile)
   {
	   if(!QFile::exists(strfile))
	   {
		   return;
	   }
	    QFile file(strfile);
	    if(!file.open(QFile::ReadWrite))
		{
		  return;
		}
		QTextStream userFileStream(&file);
		//Ȱļÿһж
		QStringList strlis;
		while(!userFileStream.atEnd())
		{
		QString lineIni=userFileStream.readLine();
		strlis<<lineIni;

		}
		//ɾ½
		file.remove();
		file.close();
		QFile file1(strfile);
		QFileInfo fi(file1);
		QString strxpnname=fi.fileName();
		strxpnname.replace(QString("."), QString("_"));
		if(!file1.open(QFile::ReadWrite))
		{
		return;
		}
		QTextStream newInputStream(&file1);
		for (int i = 0;i < strlis.size();i++)
		{
			if (i != 1)
			{
			  newInputStream<<strlis.at(i)<<"\n";
			}
			if (i == 1)
			{
			  newInputStream<<"static char * "<< strxpnname<<"[]={"<<"\n";
			}
		}
		file1.close();


 }
//4. ͼ
//
//ͼŲscaledԭ
//
//QImage QImage::scaled ( const QSize & size,Qt::AspectRatioMode aspectRatioMode = Qt::IgnoreAspectRatio, Qt::TransformationModetransformMode = Qt::FastTransformation ) const
//
//ʹ÷£img
//
//QImage* imgScaled = new QImage*imgScaled=img->scaled(width,                       height,                       Qt::KeepAspectRatio);ui->label->setPixmap(QPixmap::fromImage(*imgScaled));scaledwidthheightʾźͼĿ͸ߣԭͼŵ(width,height)С
//
//5. ͼת
//
//ͼתQImagetransformedtransformedQMatrixQMatrixָתĽǶȡ
//
//£
//
//QImage* imgRatate = new QImage;QMatrix matrix;matrix.rotate(270);*imgRotate = img->transformed(matrix);ui->label->setPixmap(QPixmap::fromImage(*imgRotate));ע⣺rotateвתĽǶȣתǰ˳ʱ뷽תģ˳ʱת270ȣʱת90ȡ
//
//6. ͼ
//ͼŵĻͿʵͼţԷһ򻬸(ĽͲ׼Horizontal Slider )ֵλʵͼš
//
//Horizontal SliderֵָΪvalueźͼΪ
//
//img->scaled(orignalWidth*value/100,
//                         orignalHeight*value/100,
//                         Qt::KeepAspectRatio);
//
//orignalWidthorignalHeightΪԭʼͼĿ͸ߡ
//
//ע⣺ڶԭʼͼŶٱʱӦĲۺֻҪHorizontal SlidersetValueɣΪHorizontal Sliderֵָһ仯ͻᴥӦĲۺͼš

